diff --git a/django/core/management/templates.py b/django/core/management/templates.py
index 0a6a3a8..1d26e97 100644
--- a/django/core/management/templates.py
+++ b/django/core/management/templates.py
@@ -48,6 +48,11 @@ class TemplateCommand(BaseCommand):
                     help='The file extension(s) to render (default: "py") '
                          'Separate multiple extensions with commas, or use '
                          '-e multiple times.'),
+        make_option('--name', '-n', dest='files',
+                    action='append', default=[],
+                    help='The file name(s) to render '
+                         'Separate multiple extensions with commas, or use '
+                         '-n multiple times.')
         )
     requires_model_validation = False
     # Can't import settings during this command, because they haven't
@@ -89,10 +94,16 @@ class TemplateCommand(BaseCommand):
 
         extensions = tuple(
             handle_extensions(options.get('extensions'), ignored=()))
+        extra_files = []
+        for file in options.get('files'):
+            extra_files.extend(map(lambda x: x.strip(), file.split(',')))
         if self.verbosity >= 2:
             self.stdout.write("Rendering %s template files with "
                               "extensions: %s\n" %
                               (app_or_project, ', '.join(extensions)))
+            self.stdout.write("Rendering %s template files with "
+                              "filenames: %s\n" %
+                              (app_or_project, ', '.join(extra_files)))
 
         base_name = '%s_name' % app_or_project
         base_subdir = '%s_template' % app_or_project
@@ -142,7 +153,7 @@ class TemplateCommand(BaseCommand):
                 # accidentally render Django templates files
                 with open(old_path, 'r') as template_file:
                     content = template_file.read()
-                if filename.endswith(extensions):
+                if filename.endswith(extensions) or filename in extra_files:
                     template = Template(content)
                     content = template.render(context)
                 with open(new_path, 'w') as new_file:
diff --git a/docs/ref/django-admin.txt b/docs/ref/django-admin.txt
index 4bde86c..a44bcff 100644
--- a/docs/ref/django-admin.txt
+++ b/docs/ref/django-admin.txt
@@ -951,7 +951,8 @@ creating the ``myapp`` app::
 
 When Django copies the app template files, it also renders the files
 whose extension matches those passed with the ``--extension`` option (``py``
-by default) using the template engine. The :class:`template context
+by default) and those files which names are passed with the ``--name`` option
+using the template engine. The :class:`template context
 <django.template.Context>` used is:
 
 - Any option passed to the startapp command
@@ -1013,7 +1014,8 @@ when creating the ``myproject`` project::
 
 When Django copies the project template files, it will also render the files
 whose extension matches those passed with the ``--extension`` option (``py``
-by default) using the template engine. The :class:`template context
+by default) and those files which names are passed with the ``--name`` option
+using the template engine. The :class:`template context
 <django.template.Context>` used is:
 
 - Any option passed to the startproject command
diff --git a/tests/regressiontests/admin_scripts/custom_templates/project_template/additional_dir/Procfile b/tests/regressiontests/admin_scripts/custom_templates/project_template/additional_dir/Procfile
new file mode 100644
index 0000000..032f0bc
--- /dev/null
+++ b/tests/regressiontests/admin_scripts/custom_templates/project_template/additional_dir/Procfile
@@ -0,0 +1 @@
+# some file for {{ project_name }} test project
\ No newline at end of file
diff --git a/tests/regressiontests/admin_scripts/custom_templates/project_template/additional_dir/requirements.txt b/tests/regressiontests/admin_scripts/custom_templates/project_template/additional_dir/requirements.txt
new file mode 100644
index 0000000..032f0bc
--- /dev/null
+++ b/tests/regressiontests/admin_scripts/custom_templates/project_template/additional_dir/requirements.txt
@@ -0,0 +1 @@
+# some file for {{ project_name }} test project
\ No newline at end of file
diff --git a/tests/regressiontests/admin_scripts/tests.py b/tests/regressiontests/admin_scripts/tests.py
index 17a2ccb..3939825 100644
--- a/tests/regressiontests/admin_scripts/tests.py
+++ b/tests/regressiontests/admin_scripts/tests.py
@@ -1489,3 +1489,21 @@ class StartProject(LiveServerTestCase, AdminScriptTestCase):
         self.assertNoOutput(err)
         self.assertTrue(os.path.isdir(testproject_dir))
         self.assertTrue(os.path.exists(os.path.join(testproject_dir, 'run.py')))
+
+    def test_custom_project_template(self):
+        "Make sure the startproject management command is able to render custom files"
+        template_path = os.path.join(test_dir, 'admin_scripts', 'custom_templates', 'project_template')
+        args = ['startproject', '--template', template_path, 'customtestproject', '-e', 'txt', '-n', 'Procfile']
+        testproject_dir = os.path.join(test_dir, 'customtestproject')
+
+        out, err = self.run_django_admin(args)
+        self.addCleanup(shutil.rmtree, testproject_dir)
+        self.assertNoOutput(err)
+        self.assertTrue(os.path.isdir(testproject_dir))
+        self.assertTrue(os.path.exists(os.path.join(testproject_dir, 'additional_dir')))
+        base_path = os.path.join(testproject_dir, 'additional_dir')
+        for f in ('Procfile', 'additional_file.py', 'requirements.txt'):
+            self.assertTrue(os.path.exists(os.path.join(base_path, f)))
+            with open(os.path.join(base_path, f)) as fh:
+                self.assertEqual(fh.read(),
+                    '# some file for customtestproject test project')